/*
 
 Esercizio 4 lez. 23/03

 Programma decompressore

*/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 100

// funzione per la lettura dell'input (vedi compressore)
char **leggiInput(int *N){

 char ** stringhe;
 char ** tmp;	
 int i;
 int capacita = 1;
 int numStringhe;


  stringhe = (char **) malloc( sizeof(char*)* capacita );
  if( stringhe == NULL ) return NULL;
  
  numStringhe = 0;
  char buff[MAXLEN+1];  

  // raccoglie le query in un array costruito mediante doubling
 
  while(scanf("%s",buff) == 1) {  // termina il ciclo di input della query quando riceve EOF
    
    stringhe[numStringhe] = (char*)malloc(sizeof(char)*(MAXLEN+1));

    for (i=0; i <= strlen(buff); i++) /* occorre copiare anche lo \0 terminale */
      stringhe[numStringhe][i] = buff[i];
           
    numStringhe++;                       

    if (numStringhe == capacita) {     
	  capacita *= 2;               
	  tmp = (char **) malloc( sizeof(char*) * capacita );
	  if( tmp == NULL ) return NULL;	
	    
	  for (i = 0; i < numStringhe; i++ ) 
	      tmp[i] = stringhe[i];

	  free(stringhe);                     
	  stringhe = tmp;                   
      }
  
  }  
 
  *N = numStringhe;
  return stringhe;
 
}


/* Convertitore da stringhe a interi per uso domestico. Legge una stringa 
 * contenente la rappresentazione decimale di un intero (seguita eventualmente da caratteri non numerici) 
 * e restituisce l'intero rappresentato. Qualora servisse utilizzare la funzione int atoi(char*) di stdlib.h, 
 * che ha la stessa interfaccia ma è più robusta.  
 */

int my_atoi(char *s){

 int res=0;

 // legge la rappresentazione decimale fermandosi al primo carattere che non è una cifra 
 
 for (; *s >='0' && *s<='9'; s++)
   res = 10*res + (*s - '0');
  
 return res;
}

/* 
 * Decodifica di una stringa letta da input. Il risultato della decodifica viene
 * scritto in OUT, che va pre-allocato della dimensione opportuna. Il parametro SOURCE  
 * contiene la stringa precedente nella sequenza originale.  
 */ 

void Front_Decode(char *IN, char *OUT, char *SOURCE) {

 int lcp,i;
 char *SUFF;

 lcp = atoi(IN); // calcola l'intero rappresentato dalle cifre iniziali di IN

 // copia il prefisso comune da SOURCE
 for(i=0; i<lcp; i++)
  *OUT++= SOURCE[i];
 
 //individua il suffisso non codificato
 for (SUFF = IN; *SUFF >= '0' && *SUFF <= '9'; SUFF++); 
 
 // e lo appende 
 for (i=0; SUFF[i] != '\0'; i++) 
	 *OUT++ = SUFF[i];

 *OUT = '\0';

}




int main() {

char ** stringhe;
int numStringhe,i;	 
char *out, *prev, *tmp;
out = (char*)malloc(sizeof(char)*(MAXLEN+1));
prev = (char*)malloc(sizeof(char)*(MAXLEN+1));
    		      
stringhe = leggiInput(&numStringhe);
if (stringhe == NULL) return 1;
 
prev[0] = '\0';   // decodifica la prima stringa in funzione di "" 
for (i=0; i< numStringhe; i++) {
  Front_Decode(stringhe[i],out,prev);
  printf("%s\n",out);
  tmp = out;
  out = prev;
  prev = tmp;
}

return 0;

}
