/*
 
 Esercizio 4 lez. 23/03

 Programma compressore

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLEN 100

/*
 * Lettura di una sequenza di stringhe di lunghezza non nota tramite doubling.
 * Restituisce un array di char* conentente puntatori alle stringhe e scrive la lunghezza della sequenza   
 * in N.
 */

char **leggiInput(int *N){

 char ** stringhe;
 char ** tmp;	
 int i;
 int capacita = 1;
 int numStringhe;


  stringhe = (char **) malloc( sizeof(char*)* capacita );
  if( stringhe == NULL ) return NULL;
  
  numStringhe = 0;
  char buff[MAXLEN+1];  

  // raccoglie le query in un array costruito mediante doubling
 
  while(scanf("%s",buff) == 1) {  // termina il ciclo di input della query quando riceve EOF
    
    stringhe[numStringhe] = (char*)malloc(sizeof(char)*(MAXLEN+1));

    for (i=0; i <= strlen(buff); i++)   // occorre copiare anche lo \0 terminale 
      stringhe[numStringhe][i] = buff[i];
           
    numStringhe++;                       

    if (numStringhe == capacita) {     
	  capacita *= 2;               
	  tmp = (char **) malloc( sizeof(char*) * capacita );
	  if( tmp == NULL ) return NULL;	
	    
	  for (i = 0; i < numStringhe; i++ ) 
	      tmp[i] = stringhe[i];

	  free(stringhe);                     
	  stringhe = tmp;                   
      }
  
  }  
 
  *N = numStringhe;
  return stringhe;
}


// determina il prefisso pi lungo in comune tra le stringhe s1 ed s2

int Longest_Common_Prefix(char *s1, char *s2){

 int len;
 for (len=0; s1[len] != '\0' && s1[len] == s2[len]; len++);

 return len;
}


/* 
 * Codifica la stringa IN mediante front-coding. Il risultato della codifica viene
 * stampato in output. Occorre passare come SOURCE la stringa precedente nell'insieme 
 *  (o la stringa di lunghezza 0 se IN  la prima). 
 */ 


void Front_Encode(char *IN, char *SOURCE){

 int lcp = Longest_Common_Prefix(IN, SOURCE);
  
 printf("%d",lcp);
 printf("%s", IN+lcp);
 printf("%c",'\n');

}


int main() {

char ** stringhe;
int numStringhe,i;	 
    		      
stringhe =leggiInput(&numStringhe);
if (stringhe == NULL) return 1;
 
 Front_Encode(stringhe[0],"");   // codifica la prima stringa in funzione di "" 
 for (i=1; i< numStringhe; i++) 
   Front_Encode(stringhe[i],stringhe[i-1]);

 return 0;

}

