/*
   Esercizio 3 lez.23/03 : Intersezione tra insiemi in tempo lineare.
   Scrivere un programma che accetti in input dall’utente due sequenze ordinate di interi distinti e stampi gli
   elementi che occorrono in entrambe. Assumere che l’utente specifichi la lunghezza di ogni sequenza
   prima di immettere tutti i suoi elementi.

   Soluzione basata sulla procedura Merge che lavora in tempo O(|A|+|B|), dove |A| e |B| sono il numero di 
   elementi in A e in B. 
*/


#include <stdlib.h>
#include <stdio.h>

/* 
   Funzione per la lettura dell'input.
   Accetta due parametri passati per riferimento: un puntatore ad int A, e una variabile intera len.
   Al ritorno dalla funzione, A punterà ad un array contenente la sequenza di elementi inserita e 
   len conterrà la lunghezza di tale sequenza  
*/

void leggiInput(int **A, int *len){

int i;
scanf("%d",len);		    // il primo valore inserito è la lunghezza	
*A = malloc((*len) * sizeof(int));
if (*A == NULL) return;

 for (i=0; i< *len; i++)
  scanf("%d",(*A) + i);

}


int main(){

 int *A, lenA;             // A: puntatore ad array contentente gli elementi di A. lenA: numero di elementi di A
 int *B, lenB;             // idem per B
 int ai,bi;

 /* lettura dell'input tramite la funzione leggiInput, che inizializza le variabili A,B,lenA e lenB */
 
 leggiInput(&A, &lenA);   
 leggiInput(&B, &lenB);   

 if (A== NULL || B == NULL) return 1;

 /* Individua gli elementi dell'intersezione sfruttando la stessa idea  
    della procedura Merge  */

 ai=bi=0;

 while (ai < lenA && bi < lenB){

   if (A[ai] < B[bi]) ai++;
   else if (B[bi] < A[ai]) bi++; 
   else { 
    printf("%d ",A[ai]);
    bi++;
    ai++;
  }

 }

 return 0;

}


